package com.sensu.automall.activity_mycenter

import android.os.Bundle
import android.support.v4.app.Fragment
import android.support.v4.view.ViewPager
import com.jaeger.library.StatusBarUtil
import com.sensu.automall.BaseActivity
import com.sensu.automall.R
import com.sensu.automall.URL
import com.sensu.automall.adapter.DeliveryViewPagerAdapter
import com.sensu.automall.fragment.DeliveryInfoByOrderFragment
import com.sensu.automall.fragment.DeliveryInfoByStatusFragment
import com.sensu.automall.utils.RequestParams
import com.sensu.automall.widgets.CusTabLayout
import org.json.JSONObject

class DeliveryInfoActivity : BaseActivity() {

    lateinit var orderNo:String
    private lateinit var _headViewPage: ViewPager
    private lateinit var _deliveryViewPagerAdapter : DeliveryViewPagerAdapter
    private var _fragmentList : List<Fragment>? = null
    private lateinit var _tabLayout : CusTabLayout

    init {
        activity_LayoutId = R.layout.activity_delivery_info
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        cancelFullProgressView()
        StatusBarUtil.setColor(this, resources.getColor(R.color.white_text_color), 0)
        StatusBarUtil.setLightMode(this)
        orderNo = intent.getStringExtra("uid")
        getRouteByOrderNo()
    }

    override fun initView() {
        super.initView()
        _headViewPage = findViewById(R.id.head_viewpager)

        setShowLoading(false)
        titleText = "物流信息"

        initTabLayout()
        initViewPager()


    }

    private fun initViewPager() {
        var deliveryInfoByStatusFragment = DeliveryInfoByStatusFragment()
        val args = Bundle()
        args.putString("orderNo", orderNo)
        deliveryInfoByStatusFragment.arguments = args
        _fragmentList = listOf<Fragment>(deliveryInfoByStatusFragment,DeliveryInfoByOrderFragment())

        _deliveryViewPagerAdapter = DeliveryViewPagerAdapter(supportFragmentManager, _fragmentList!!,
                listOf(*activity.resources.getStringArray(R.array.delivery_title)))
        _headViewPage.adapter = _deliveryViewPagerAdapter

    }

    private fun initTabLayout() {
        _tabLayout = findViewById(R.id.tab_layout)
        _tabLayout.setupWithViewPager(_headViewPage, true)

    }

    fun getRouteByOrderNo(){
        var params:JSONObject = JSONObject()
        val orderNo = intent.getStringExtra("uid")
        params.put("orderNo",orderNo)
        client.postRequestJ("getRouteByOrderNo","https://qpl-gateway.tuhu.work/qpl-delivery/deliveryInfo/getRouteByOrderNo",params, activityKey)
    }


    override fun notifyDataChanged(`object`: JSONObject?) {
        super.notifyDataChanged(`object`)
    }


}

