package com.sensu.automall.activity_search

import android.app.Activity
import android.content.ContentResolver
import android.content.Intent
import android.graphics.Bitmap
import android.net.Uri
import android.os.Bundle
import android.provider.MediaStore
import android.view.View
import com.annotation.IRouter
import com.jaeger.library.StatusBarUtil
import com.sensu.automall.BaseActivity
import com.sensu.automall.R
import com.sensu.automall.utils.ImageUtils
import com.uuzuche.lib_zxing.activity.CaptureFragment
import com.uuzuche.lib_zxing.activity.CodeUtils
import com.uuzuche.lib_zxing.activity.CodeUtils.AnalyzeCallback
import kotlinx.android.synthetic.main.activity_capture_new.*

@IRouter(path = "/qcode", desc = "二维码扫描")
class CaptureActivityNew:BaseActivity{

    private lateinit var captureFragment : CaptureFragment
    private val REQUEST_IMAGE = 11

    constructor(){
        activity_LayoutId= R.layout.activity_capture_new
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        StatusBarUtil.setColor(this, resources.getColor(R.color.white_text_color),0)
        StatusBarUtil.setLightMode(this)
        cancelFullProgressView()
        captureFragment = CaptureFragment()
        CodeUtils.setFragmentArgs(captureFragment, R.layout.scan_dingzhi)
        captureFragment.analyzeCallback = analyzeCallback
        supportFragmentManager.beginTransaction().replace(R.id.fl_my_container, captureFragment).commit()
        choose_picture.setOnClickListener(chooseImageListener)

    }

    /**
     * 二维码解析回调函数
     */
    private var analyzeCallback: AnalyzeCallback = object : AnalyzeCallback {
        override fun onAnalyzeSuccess(mBitmap: Bitmap, result: String) {
            val resultIntent = Intent()
            val bundle = Bundle()
            bundle.putInt(CodeUtils.RESULT_TYPE, CodeUtils.RESULT_SUCCESS)
            bundle.putString(CodeUtils.RESULT_STRING, result)
            resultIntent.putExtras(bundle)
            setResult(Activity.RESULT_OK, resultIntent)
            finish()
        }

        override fun onAnalyzeFailed() {
            val resultIntent = Intent()
            val bundle = Bundle()
            bundle.putInt(CodeUtils.RESULT_TYPE, CodeUtils.RESULT_FAILED)
            bundle.putString(CodeUtils.RESULT_STRING, "")
            resultIntent.putExtras(bundle)
            setResult(Activity.RESULT_OK, resultIntent)
            finish()
        }
    }

    companion object {
        const val TYPE: String = "option_type"
        const val TYPE_P :String = "Picture"
    }

    private var analyzeCallbackP: AnalyzeCallback = object : AnalyzeCallback {
        override fun onAnalyzeSuccess(mBitmap: Bitmap, result: String) {
            val resultIntent = Intent()
            val bundle = Bundle()
            bundle.putInt(CodeUtils.RESULT_TYPE, CodeUtils.RESULT_SUCCESS)
            bundle.putString(CodeUtils.RESULT_STRING, result)
            resultIntent.putExtras(bundle)
            setResult(Activity.RESULT_OK, resultIntent)
            finish()
        }

        override fun onAnalyzeFailed() {
            val resultIntent = Intent()
            val bundle = Bundle()
            bundle.putInt(CodeUtils.RESULT_TYPE, CodeUtils.RESULT_FAILED)
            bundle.putString(CodeUtils.RESULT_STRING, "")
            bundle.putString(TYPE, TYPE_P)
            resultIntent.putExtras(bundle)
            setResult(Activity.RESULT_OK, resultIntent)
            finish()
        }
    }

    private var chooseImageListener:View.OnClickListener = View.OnClickListener {
        val intent = Intent(Intent.ACTION_GET_CONTENT)
        intent.addCategory(Intent.CATEGORY_OPENABLE)
        intent.type = "image/*"
        startActivityForResult(intent, REQUEST_IMAGE)
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == REQUEST_IMAGE){
            if(data != null){
                val uri : Uri = data.data
                val contentResolver : ContentResolver = getContentResolver()
                try {
                    val bitmap : Bitmap = MediaStore.Images.Media.getBitmap(contentResolver, uri)
                    CodeUtils.analyzeBitmap(ImageUtils.getImageAbsolutePath(this, uri), analyzeCallbackP)
                    bitmap.recycle()
                }catch (e:Exception){
                    e.printStackTrace()
                }

            }
        }
    }

    public fun backClick(view: View){
        finish()
    }
}