package com.sensu.automall.activity_search

import android.content.Intent
import android.os.Bundle
import android.support.v4.app.Fragment
import android.support.v4.view.ViewPager
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.text.TextUtils
import android.view.KeyEvent
import android.view.View
import com.annotation.IRouter
import com.qipeilong.base.commonadapter.rv.MultiItemTypeAdapter
import com.qpl.loadstate.NoDataLoadState
import com.qpl.loadstate.NoNetWorkLoadViewState
import com.sensu.automall.BaseActivity
import com.sensu.automall.R
import com.sensu.automall.URL
import com.sensu.automall.activity_main.MainActivity
import com.sensu.automall.adapter.DeliveryViewPagerAdapter
import com.sensu.automall.adapter.SearchSortLeftAdapter
import com.sensu.automall.db.SearchSortDBUtils
import com.sensu.automall.fragment.BrandAllFragment
import com.sensu.automall.fragment.DeliveryInfoByOrderFragment
import com.sensu.automall.fragment.DeliveryInfoByStatusFragment
import com.sensu.automall.fragment.SearchSortFragment
import com.sensu.automall.manager.SetStatusStrategry
import com.sensu.automall.manager.StatusStrategry
import com.sensu.automall.model.SearchSortItem
import com.sensu.automall.model.SearchSortModel
import com.sensu.automall.recyclerview.SearchSortHeadDecoration
import com.sensu.automall.recyclerview.TobeQuotePriceItemDecoration
import com.sensu.automall.utils.*
import com.sensu.automall.widgets.CusTabLayout
import io.reactivex.Observable
import kotlinx.android.synthetic.main.activity_search2.*
import org.json.JSONException
import org.json.JSONObject
import java.lang.Exception

//@IRouter(path = "/SearchActivity",desc = "分类")
class SearchActivity3:BaseActivity{

    private lateinit var _headViewPage: ViewPager
    private lateinit var _deliveryViewPagerAdapter : DeliveryViewPagerAdapter
    private var _fragmentList : List<Fragment>? = null
    private lateinit var _tabLayout : CusTabLayout

    constructor(){
        activity_LayoutId= R.layout.activity_search3
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        SetStatusStrategry(StatusStrategry.WHITE, this)
        cancelFullProgressView()
    }

    override fun initView() {
        super.initView()

        _headViewPage = findViewById(R.id.head_viewpager)

        setShowLoading(false)

        initTabLayout()
        initViewPager()

    }

    private fun initViewPager() {
        _fragmentList = listOf<Fragment>(SearchFragment(), BrandAllFragment())

        _deliveryViewPagerAdapter = DeliveryViewPagerAdapter(supportFragmentManager, _fragmentList!!,
                listOf(*activity.resources.getStringArray(R.array.search_title)))
        _headViewPage.adapter = _deliveryViewPagerAdapter

    }

    private fun initTabLayout() {
        _tabLayout = findViewById(R.id.tab_layout)
        _tabLayout.setupWithViewPager(_headViewPage, true)

    }

    // 关键字搜索
    fun searchKeywordClick(v: View) {
        startActivity(Intent(this,SearchKeywordDialogActivity::class.java).putExtra("productlist",
                Constants.PRODUCT_LIST_JUMP_SEARCH))
    }


    //语音输入
    fun voiceRecognize(v:View){
        startActivityForResult(Intent(this, VoiceRecognizeActivity::class.java), 1000)
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if(requestCode == 1000){
            if (data != null) {
                val text = data.getStringExtra("text")
                val mode_stwitch = MassageUtils.getModeStwitch(this);
                if (TextUtils.isEmpty(mode_stwitch) || mode_stwitch == SharedPreferenceUtil.MODE_SWITCH_AutoMallProductList) {
                    val intent = Intent(this, AutoMallProductListActivity::class.java)
                    intent.putExtra("keyword",text)
                    startActivity(intent)
                } else if (mode_stwitch == SharedPreferenceUtil.MODE_SWITCH_OldProductList) {
//                    OldProductListActivity.startActivity(this, "", "", "", "", text)
                    ProductListActivity.startActivity(this, "", "", "", "", text)
                }
            }
        }
    }


    override fun onKeyDown(keyCode: Int, event: KeyEvent?): Boolean {
        if ((keyCode == KeyEvent.KEYCODE_BACK && event?.action == KeyEvent.ACTION_DOWN))
        {
            if (parent is MainActivity) {
                (parent as MainActivity).tab(0)
            }
            return true
        }
        return super.onKeyDown(keyCode, event)
    }


}


