package com.sensu.automall.dialog

import android.content.Intent
import android.view.View
import com.sensu.automall.R
import com.sensu.automall.activity_search.FastEntryActivity
import com.sensu.automall.model.FastEntry
import kotlinx.android.synthetic.main.dialog_private_protocol.*

class PrivateProtocolDialog :BaseDialog(){


    override fun layoutRes(): Int {
        return R.layout.dialog_private_protocol
    }
    private var mActionListener: OnActionListener?=null

    override fun initView(view: View) {
        super.initView(view)
        btn_reject.setOnClickListener { mActionListener?.onReject() }
        btn_accept.setOnClickListener {mActionListener?.onAccept(); dismiss() }
        tv_protocol_h5.setOnClickListener { 
            val intent = Intent(context,FastEntryActivity::class.java)
            intent.putExtra("url","file:///android_asset/privacyTerms.html")
            intent.putExtra("title","汽配龙隐私权条款")
            context?.startActivity(intent)
        }
    }

    interface OnActionListener{
        fun onReject()
        fun onAccept()
    }

    fun setOnActionListener(listener: OnActionListener):PrivateProtocolDialog{
        mActionListener = listener
        return this
    }

    override fun dismiss() {
        super.dismiss()
        mActionListener = null
    }
}