package com.sensu.automall.fragment

import android.os.Bundle
import android.support.v4.app.Fragment
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import com.sensu.automall.BaseFragment
import com.sensu.automall.R
import com.sensu.automall.adapter.OrderDeliveryViewPagerAdapter
import com.sensu.automall.widgets.CusTabLayout
import kotlinx.android.synthetic.main.fragment_delivery_by_order.*

class DeliveryInfoByOrderFragment : BaseFragment(){

    private lateinit var rootView:View
    private lateinit var fragmentList : List<Fragment>
    private lateinit var viewPagerAdapter: OrderDeliveryViewPagerAdapter

    private var cusPos = 0

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        super.onCreateView(inflater, container, savedInstanceState)
        rootView = inflater.inflate(R.layout.fragment_delivery_by_order, container, false)
        return rootView
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initView()
    }

    fun initView(){
        orderTabLayout.setupWithViewPager(orderViewPager,false)
        fragmentList = listOf<Fragment>(DeliveryOrderFragment(),DeliveryOrderFragment())
        viewPagerAdapter = OrderDeliveryViewPagerAdapter(requireFragmentManager(), fragmentList)
        orderViewPager.adapter = viewPagerAdapter

        for (index in fragmentList.indices){
            val tab = orderTabLayout.getTabAt(index)
            val view = View.inflate(context, R.layout.tab_delivery_order, null)
            val tabTitle = view.findViewById<TextView>(R.id.tab_title)
            if (index == 0){
                tabTitle?.setBackgroundResource(R.drawable.bg_card_accent)
            }
            tabTitle.text = "订单$index"
            if (tab != null) {
                tab.customView = view
            }
        }
        orderTabLayout.addOnTabSelectedListener(object : CusTabLayout.OnTabSelectedListener{
            override fun onTabSelected(tab: CusTabLayout.Tab?) {
                val view:View? = tab?.customView
                val tabTitle = view?.findViewById<TextView>(R.id.tab_title)
                tabTitle?.setBackgroundResource(R.drawable.bg_card_accent)
            }

            override fun onTabUnselected(tab: CusTabLayout.Tab?) {
                val view:View? = tab?.customView
                val tabTitle = view?.findViewById<TextView>(R.id.tab_title)
                tabTitle?.setBackgroundResource(R.color.white_text_color)
            }

            override fun onTabReselected(tab: CusTabLayout.Tab?) {

            }

        })
    }


}
