package com.sensu.automall.view

import android.content.Context
import android.graphics.Rect
import android.graphics.drawable.ColorDrawable
import android.support.v7.widget.GridLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.LinearLayout
import android.widget.PopupWindow
import android.widget.TextView
import com.sensu.automall.R
import com.sensu.automall.model.Brand
import java.util.*

class FilterPopupWindow(context: Context, listener: OnDismissListener) : PopupWindow(context) {
    var brands_select: MutableMap<String, Boolean> = HashMap()
    var btn_sure: TextView
    var btn_reset: TextView

    var is_self_tv:TextView
    var is_group_tv:TextView
    var post_tv:TextView
    var is_stock_tv:TextView
    var context:Context

    private var is_self = ""
    private var is_post = ""
    private var is_group = ""
    private var is_stock = ""



    override fun dismiss() {
        super.dismiss()
    }

    fun setStatus(is_self:String, is_post:String, is_group:String, is_stock:String){
        this.is_self = is_self
        this.is_post = is_post
        this.is_group = is_group
        this.is_stock = is_stock
        refreshView()
    }

    fun refreshView(){
        if (is_self =="1"){
            is_self_tv.setBackgroundResource(R.drawable.brand_select)
            is_self_tv.setTextColor(context.resources.getColor(R.color.accent_red))
        }else{
            is_self_tv.setBackgroundResource(R.drawable.brand_no_select)
            is_self_tv.setTextColor(context.resources.getColor(R.color.light_deep_gray))
        }

        if (is_post =="1"){
            post_tv.setBackgroundResource(R.drawable.brand_select)
            post_tv.setTextColor(context.resources.getColor(R.color.accent_red))
        }else{
            post_tv.setBackgroundResource(R.drawable.brand_no_select)
            post_tv.setTextColor(context.resources.getColor(R.color.light_deep_gray))
        }

        if (is_group =="1"){
            is_group_tv.setBackgroundResource(R.drawable.brand_select)
            is_group_tv.setTextColor(context.resources.getColor(R.color.accent_red))
        }else{
            is_group_tv.setBackgroundResource(R.drawable.brand_no_select)
            is_group_tv.setTextColor(context.resources.getColor(R.color.light_deep_gray))
        }

        if (is_stock =="1"){
            is_stock_tv.setBackgroundResource(R.drawable.brand_select)
            is_stock_tv.setTextColor(context.resources.getColor(R.color.accent_red))
        }else{
            is_stock_tv.setBackgroundResource(R.drawable.brand_no_select)
            is_stock_tv.setTextColor(context.resources.getColor(R.color.light_deep_gray))
        }
    }

    internal inner class SpaceItemDecoration(var space: Int) : RecyclerView.ItemDecoration() {
        override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State) {
            super.getItemOffsets(outRect, view, parent, state)
            outRect.left = space
            outRect.right = space
            outRect.top = space
        }

    }

    interface OnSureClicklistener {
        fun onSure(is_self:String, is_post:String, is_group:String, is_stock:String)
    }

    private var onSureClicklistener: OnSureClicklistener? = null
    fun setOnSureClicklistener(listener: OnSureClicklistener?) {
        onSureClicklistener = listener
    }

    init {
        val contentView = LayoutInflater.from(context).inflate(R.layout.filter_popup_window, null)

        is_self_tv = contentView.findViewById(R.id.is_self_tv)
        is_group_tv = contentView.findViewById(R.id.is_group_tv)
        post_tv = contentView.findViewById(R.id.post_tv)
        is_stock_tv = contentView.findViewById(R.id.is_stock_tv)


        val clickListener : View.OnClickListener = View.OnClickListener{
            when(it.id){
                (R.id.is_self_tv)->{
                    if ("1"==is_self){
                        is_self =""
                    }else{
                        is_self ="1"
                    }
                    refreshView()
                }
                (R.id.is_group_tv)->{
                    if ("1"==is_group){
                        is_group =""
                    }else{
                        is_group ="1"
                    }
                    refreshView()
                }
                (R.id.post_tv)->{
                    if ("1"==is_post){
                        is_post =""
                    }else{
                        is_post ="1"
                    }
                    refreshView()
                }
                (R.id.is_stock_tv)->{
                    if ("1"==is_stock){
                        is_stock =""
                    }else{
                        is_stock ="1"
                    }
                    refreshView()
                }

            }
        }
        is_self_tv.setOnClickListener(clickListener)
        is_group_tv.setOnClickListener(clickListener)
        post_tv.setOnClickListener(clickListener)
        is_stock_tv.setOnClickListener(clickListener)

        btn_sure = contentView.findViewById<View>(R.id.btn_sure) as TextView
        btn_sure.setOnClickListener {
            if (onSureClicklistener != null) {
                onSureClicklistener!!.onSure(is_self, is_post, is_group, is_stock)
            }
            dismiss()
        }
        btn_reset = contentView.findViewById<View>(R.id.btn_reset) as TextView
        btn_reset.setOnClickListener {
            is_self=""
            is_post=""
            is_group=""
            is_stock=""
            refreshView()
        }
        contentView!!.setOnClickListener { dismiss() }
        setContentView(contentView)

        //设置SelectPicPopupWindow弹出窗体的宽
        this.width = ViewGroup.LayoutParams.MATCH_PARENT
        //设置SelectPicPopupWindow弹出窗体的高
        this.height = ViewGroup.LayoutParams.MATCH_PARENT
        this.isFocusable = true
        this.isTouchable = true
        this.isOutsideTouchable = false
        this.setOnDismissListener(listener)
        this.context = context
        setBackgroundDrawable(ColorDrawable(0x00000000))
    }
}