package com.sensu.automall.view

import android.app.Activity
import android.content.Context
import android.graphics.Rect
import android.graphics.drawable.ColorDrawable
import android.support.v7.widget.GridLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.LinearLayout
import android.widget.PopupWindow
import android.widget.TextView
import com.sensu.automall.R
import com.sensu.automall.model.ChildAttrItem
import java.util.*

class ProductListAttributePopup(context: Context, listener:OnDismissListener) : PopupWindow(context) {
    val context: Context
    var gridLayoutManager: GridLayoutManager
    var list: MutableList<ChildAttrItem>? = ArrayList()
    var recyclerView: RecyclerView? = null
    var ll_brandwindow: LinearLayout? = null
    var btn_sure: TextView
    var btn_reset: TextView
    private var adapter: BrandAdapter? = null
    var extMap_item: MutableMap<ChildAttrItem, Boolean?> = HashMap()
    fun setList(list: List<ChildAttrItem>, extMap_item: Map<ChildAttrItem, Boolean?>?) {
        this.list!!.clear()
        this.list!!.addAll(list)
        this.extMap_item.clear()
        this.extMap_item.putAll(extMap_item!!)
        adapter!!.notifyDataSetChanged()
    }

    override fun dismiss() {
        super.dismiss()
    }

    private inner class BrandAdapter : RecyclerView.Adapter<BrandAdapter.ViewHolder>() {
        override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
            val view = LayoutInflater.from(parent.context).inflate(R.layout.item_product_list_attr, parent, false)
            return ViewHolder(view)
        }

        override fun onBindViewHolder(holder: ViewHolder, position: Int) {
            holder.setView(position)
        }

        override fun getItemCount(): Int {
            return if (list == null) 0 else list!!.size
        }

        internal inner class ViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
            private val txt_attr: TextView
            private val container:ViewGroup
            fun setView(position: Int) {
                txt_attr.text = list!![position].getValue()
                if (extMap_item.containsKey(list!![position])) {
                    if (extMap_item[list!![position]]!!) {
                        container.setBackgroundResource(R.drawable.brand_select)
                        txt_attr.setTextColor(context.resources.getColor(R.color.accent_red))
                    } else {
                        container.setBackgroundResource(R.drawable.brand_no_select)
                        txt_attr.setTextColor(context.resources.getColor(R.color.light_deep_gray))
                    }
                } else {
                    container.setBackgroundResource(R.drawable.brand_no_select)
                    txt_attr.setTextColor(context.resources.getColor(R.color.light_deep_gray))
                }
                txt_attr.setOnClickListener {
                    if (extMap_item.containsKey(list!![position])) {
                        if (extMap_item[list!![position]]!!) {
                            extMap_item[list!![position]] = false
                            container.setBackgroundResource(R.drawable.brand_no_select)
                            txt_attr.setTextColor(context.resources.getColor(R.color.light_deep_gray))
                        } else {
                            extMap_item[list!![position]] = true
                            container.setBackgroundResource(R.drawable.brand_select)
                            txt_attr.setTextColor(context.resources.getColor(R.color.accent_red))
                        }
                    } else {
                        extMap_item[list!![position]] = true
                    }
                    adapter!!.notifyDataSetChanged()
                }
            }

            init {
                txt_attr = itemView.findViewById<View>(R.id.txt_category) as TextView
                container = itemView.findViewById(R.id.container)
            }
        }
    }

    internal inner class SpaceItemDecoration(var space: Int) : RecyclerView.ItemDecoration() {
        override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State) {
            super.getItemOffsets(outRect, view, parent, state)
            outRect.left = space
            outRect.right = space
            outRect.top = space
        }

    }

    interface OnSureClicklistener {
        fun onSure(extMap_item: Map<ChildAttrItem, Boolean?>)
    }

    private var onSureClicklistener: OnSureClicklistener? = null

    fun setOnSureClicklistener(listener: OnSureClicklistener?) {
        onSureClicklistener = listener
    }

    init {
        this.context = context
        val mContentView = LayoutInflater.from(context).inflate(R.layout.popup_attrs, null)
        recyclerView = mContentView.findViewById<View>(R.id.recyclerview_brandpop) as RecyclerView
        ll_brandwindow = mContentView.findViewById<View>(R.id.ll_brandwindow) as LinearLayout
        btn_sure = mContentView.findViewById<View>(R.id.btn_sure) as TextView
        btn_sure.setOnClickListener {
            if (onSureClicklistener != null) {
                onSureClicklistener!!.onSure(extMap_item)
            }
            dismiss()
        }
        btn_reset = mContentView.findViewById<View>(R.id.btn_reset) as TextView
        btn_reset.setOnClickListener {
            for (i in list!!.indices) {
                if (extMap_item.containsKey(list!![i])) {
                    extMap_item[list!![i]] = false
                }
            }
            adapter!!.notifyDataSetChanged()
        }
        ll_brandwindow!!.setOnClickListener { dismiss() }
        gridLayoutManager = GridLayoutManager(context, 3)
        recyclerView!!.setHasFixedSize(true)
        recyclerView!!.layoutManager = gridLayoutManager
        recyclerView!!.addItemDecoration(SpaceItemDecoration(10))
        adapter = BrandAdapter()
        recyclerView!!.adapter = adapter
        contentView = mContentView
        //设置SelectPicPopupWindow弹出窗体的宽
        this.width = ViewGroup.LayoutParams.MATCH_PARENT
        //设置SelectPicPopupWindow弹出窗体的高
        this.height = ViewGroup.LayoutParams.MATCH_PARENT
        this.isFocusable = true
        this.isTouchable = true
        this.isOutsideTouchable = false
        this.setOnDismissListener (listener)
        setBackgroundDrawable(ColorDrawable(0x00000000))
    }
}