package com.sensu.automall.view

import android.content.Context
import android.graphics.Rect
import android.graphics.drawable.ColorDrawable
import android.support.v7.widget.GridLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.LinearLayout
import android.widget.PopupWindow
import android.widget.TextView
import com.sensu.automall.R
import com.sensu.automall.model.Brand
import com.sensu.automall.model.CataLogJ
import java.util.*

class ProductListCatalogPopupWindow(context: Context, listener:OnDismissListener) : PopupWindow(context) {
    var gridLayoutManager: GridLayoutManager
    val context:Context
    var cataLogs: MutableList<CataLogJ> = ArrayList()
    var recyclerView: RecyclerView? = null
    var ll_brandwindow: LinearLayout? = null
    var cusCatalogId: String = ""
    var cusCatalogName : String =""
    var btn_sure: TextView
    var btn_reset: TextView
    private var adapter: BrandAdapter? = null
    fun setList(cataLogs: MutableList<CataLogJ>, cusCatalogId: String) {
        this.cataLogs.clear()
        this.cataLogs.addAll(cataLogs)
        this.cusCatalogId = cusCatalogId
        adapter!!.notifyDataSetChanged()
    }

    override fun dismiss() {
        super.dismiss()
    }

    private inner class BrandAdapter : RecyclerView.Adapter<BrandAdapter.ViewHolder>() {
        override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
            val view = LayoutInflater.from(parent.context).inflate(R.layout.item_product_list_brand, parent, false)
            return ViewHolder(view)
        }

        override fun onBindViewHolder(holder: ViewHolder, position: Int) {
            holder.setView(position)
        }

        override fun getItemCount(): Int {
            return cataLogs.size
        }

        internal inner class ViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
            private val txt_brand: TextView
            private val container:ViewGroup
            fun setView(position: Int) {
                val amountString : String
                if("全部"==cataLogs[position].catalogName){
                    amountString = ""
                }else{
                    if (cataLogs[position].productCount > 999){
                        amountString = "(999+)"
                    } else{
                        amountString = "("+ cataLogs[position].productCount+ ")"
                    }
                }
                txt_brand.text = (cataLogs[position].catalogName + amountString)

                if (cusCatalogId == cataLogs[position].catalogId) {
                    container.setBackgroundResource(R.drawable.brand_select)
                    txt_brand.setTextColor(context.resources.getColor(R.color.accent_red))
                } else {
                    container.setBackgroundResource(R.drawable.brand_no_select)
                    txt_brand.setTextColor(context.resources.getColor(R.color.light_deep_gray))
                }

                container.setOnClickListener {
                   if (cusCatalogId == cataLogs[position].catalogId) {
                       cusCatalogId =  ""
                       cusCatalogName = ""
                    } else {
                       cusCatalogId = cataLogs[position].catalogId
                       cusCatalogName = cataLogs[position].catalogName
                    }
                    adapter!!.notifyDataSetChanged()
                }
            }

            init {
                txt_brand = itemView.findViewById<View>(R.id.txt_category) as TextView
                container = itemView.findViewById(R.id.container)
            }
        }
    }

    internal inner class SpaceItemDecoration(var space: Int) : RecyclerView.ItemDecoration() {
        override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State) {
            super.getItemOffsets(outRect, view, parent, state)
            outRect.left = space
            outRect.right = space
            outRect.top = space
        }

    }

    interface OnSureClicklistener {
        fun onSure(selectedId:String , selectedName:String)
    }

    private var onSureClicklistener: OnSureClicklistener? = null
    fun setOnSureClicklistener(listener: OnSureClicklistener?) {
        onSureClicklistener = listener
    }

    init {
        this.context = context
        val contentView = LayoutInflater.from(context).inflate(R.layout.popup_brand, null)
        recyclerView = contentView.findViewById<View>(R.id.recyclerview_brandpop) as RecyclerView
        ll_brandwindow = contentView.findViewById<View>(R.id.ll_brandwindow) as LinearLayout
        btn_sure = contentView.findViewById<View>(R.id.btn_sure) as TextView
        btn_sure.setOnClickListener {
            if (onSureClicklistener != null) {
                onSureClicklistener!!.onSure(cusCatalogId, cusCatalogName)
            }
            dismiss()
        }
        btn_reset = contentView.findViewById<View>(R.id.btn_reset) as TextView
        btn_reset.setOnClickListener {
            cusCatalogId = ""
            adapter!!.notifyDataSetChanged()
        }
        ll_brandwindow!!.setOnClickListener { dismiss() }
        gridLayoutManager = GridLayoutManager(context, 2)
        recyclerView!!.setHasFixedSize(true)
        recyclerView!!.layoutManager = gridLayoutManager
        recyclerView!!.addItemDecoration(SpaceItemDecoration(20))
        adapter = BrandAdapter()
        recyclerView!!.adapter = adapter
        setContentView(contentView)

        //设置SelectPicPopupWindow弹出窗体的宽
        this.width = ViewGroup.LayoutParams.MATCH_PARENT
        //设置SelectPicPopupWindow弹出窗体的高
        this.height = ViewGroup.LayoutParams.MATCH_PARENT
        this.isFocusable = true
        this.isTouchable = true
        this.isOutsideTouchable = false
        this.setOnDismissListener(listener)
        setBackgroundDrawable(ColorDrawable(0x00000000))
    }
}